;------- TASM ASM mnemonics. -------
; Compile this file using:
; Set TASMOPTS = -b
; tasm -80 ThisCode.tas MyBinary.BIN
;-----------------------------------
; Zx81 Program name: VB81 XuR [Severly Limited-var2.p] :
; REM   line   name: D=16458/16600 : H=404A/40D8

#define ORG  .org       ; TASM cross-assembler definitions
#define equ  .equ
;-----------------------------------

;------- Rom and Ram Symbols -------
DFile equ $400C
Frames equ $4034


ORG $404A

	LD HL,(DFile)
	LD BC,$026F
	ADD HL,BC
	INC BC
Lb4052:
	LD (HL),$76
	DEC HL
	DEC BC
	LD A,B
	OR C
	JR NZ, Lb4052

	LD HL,(DFile)		;Print "Noice" section
	LD BC,$01F1
	ADD HL,BC
	LD DE,Noice
	LD B,$05
Lb4066:
	LD C,B
	LD B,$09
Lb4069:
	LD (HL),$00
	INC HL
	DJNZ Lb4069

	LD B,$0F		;Print "ZigZags" section
Lb4070:
	LD A,(DE)
	LD (HL),A
	INC HL
	INC DE
	DJNZ Lb4070
	LD B,C
	DJNZ Lb4066
Lb4079:
	LD DE,(DFile)
	LD A,$76
	LD (DE),A 
	INC DE 
	LD B,$0F 
Lb4083:
	LD A,B 
	RL A 
	RL A 
	LD C,A 
	LD A,(Frames)
	ADD A,C 
	AND $3F 
	PUSH BC 
	LD C,A 
	LD B,$00 
	LD HL, Group02
	ADD HL,BC 
	LD A,(HL) 
	LD C,A 
	LD HL, Group01
	ADD HL,BC 
	LD BC,$0020 
	LDIR 
	LD A,$76 
	LD (DE),A 
	INC DE 
	POP BC 
	DJNZ Lb4083
	JP Lb4079

Group01:
.db $08,$0A,$09,$00,$00,$0A,$09,$0A; DATA
.db $08,$89,$8A,$89,$80,$80,$8A,$89; DATA
.db $8A,$08,$09,$0A,$09,$00,$00,$0A; DATA
.db $09,$0A,$08,$89,$8A,$89,$80,$80; DATA
.db $8A,$89,$8A,$08,$09,$0A,$09,$00; DATA
.db $00,$0A,$09,$0A; DATA

Group02:
.db $06,$06,$07,$07,$08,$08,$09,$09; DATA
.db $0A,$0A,$0A,$0B,$0B,$0B,$0B,$0B; DATA
.db $0B,$0B,$0B,$0B,$0B,$0B,$0A,$0A; DATA
.db $0A,$09,$09,$08,$08,$07,$07,$06; DATA
.db $05,$05,$04,$04,$03,$03,$02,$02; DATA
.db $01,$01,$01,$00,$00,$00,$00,$00; DATA
.db $00,$00,$00,$00,$00,$00,$01,$01; DATA
.db $01,$02,$02,$03,$03,$04,$04,$05; DATA

Noice:
.db $07,$03,$03,$07,$03,$03,$07,$84; DATA
.db $03,$03,$84,$03,$03,$84,$76,$05; DATA
.db $87,$00,$05,$87,$00,$82,$81,$00; DATA
.db $04,$85,$00,$83,$81,$76,$05,$85; DATA
.db $00,$05,$85,$00,$05,$85,$00,$07; DATA
.db $84,$00,$83,$82,$76,$05,$85,$00; DATA
.db $05,$00,$00,$05,$85,$00,$00,$85; DATA
.db $00,$00,$85,$76,$03,$03,$03,$03; DATA
.db $03,$03,$03,$03,$03,$03,$03,$03; DATA
.db $03,$03; DATA

.end

